# NOTE: Derived from blib/lib/Text/EP3.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package Text::EP3;

#line 1264 "blib/lib/Text/EP3.pm (autosplit into blib/lib/auto/Text/EP3/include.al)"
sub include
# Include a file for processing
# usage: @include "file"  or <file>
# the @{$self->{Include_Directory}} is the search path if the file is included with
# <>, if the file is included with "", then the current directory is prepended
# to @${self->{Include_Directory}).
{
    my $self = shift;
    my (@input_string) = @_;
    my (@string);
    my ($inline, $directive, $key);
    my ($condition);
    my ($file, $result, $dir);
    my ($current_dir);
    my $start_pattern = quotemeta $self->{Start_Comment}; 
    my $line_pattern = quotemeta $self->{Line_Comment}; 
    my $return_line = $Text::EP3::line + 1;
 
    $inline = $input_string[0];
    @string = split(' ',$inline);
    print "$self->{Line_Comment}EP3->include: Entered include.  Line $Text::EP3::line of $Text::EP3::filename   $string[1]\n"		if $self->{Debug} & 1;
 
    # parse key string
    $directive = shift @string;
    $file = shift @string;
 
    # make sure there is a key
    if ($file eq '') {
       die "No file for $directive";
    }

    # check for conditional string
    #@string ? $condition = shift @string : $condition = '';
    $condition = shift @string ;
    print "$self->{Line_Comment}EP3->include: $directive condition is $condition\n" if $self->{Debug} & 8;
 
    if (!defined $condition || $condition =~ /(^$line_pattern|^$start_pattern)/ ) {
        $condition = '';	# Was a comment. ignore.
    }
 
    if ($file =~ /"(.*)"/) {
        $current_dir = cwd();
        $file = $1;
    }
    elsif ($file =~ /<(.*)>/) {
        $current_dir = '';
        $file = $1;
    }
    else {
        die "$directive: invalid include $file";
    }

    #Check if the file is absolute.
    $result = 0;
    if ($file =~ /^\//) {
        $result = 1 if (-e $file);
    }
    else {
        foreach $dir ($current_dir, @{$self->{Include_Directory}}) {
            print "$self->{Line_Comment}EP3->include: Checking $dir/$file\n" if
            $self->{Debug} & 8;
            $result = 1 if (-e "$dir/$file");
            if ($result) {
                print "$self->{Line_Comment}EP3->include: include: $dir/$file\n"	if $self->{Debug} & 8;
                # Change file so it is now absolute.
                $file = "$dir/$file";
                last; # got one, so exit the loop
            }
        }
    }
 
    if (! $result) {
        die "$directive: couldn't find $file: $!";
    }
    else {
        # Print the file in the dependlist and then read it
        print $Text::EP3::Dependfile_Handle "$file\n" if $self->{Gen_Depend_List};
        print "$self->{Line_Comment}EP3->include: include: Getting ready to iterate with file ->$file<- and condition ->$condition<-\n"	if $self->{Debug} & 8;
        # Iteratively process this file
        $self->ep3_process ($file, $condition);
    }
    print "\n$self->{Delimeter} $return_line \"$Text::EP3::filename\" 2\n" if $self->{Sync_Lines};
}

# end of Text::EP3::include
1;
